Linus Torvalds | a3e870f | 2005-05-30 12:51:00 -0700 | [diff] [blame] | 1 | #!/bin/sh |
Junio C Hamano | 5fec3ef | 2005-06-25 02:22:05 -0700 | [diff] [blame] | 2 | # |
| 3 | # Copyright (c) 2005 Linus Torvalds |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 4 | # Copyright (c) 2006 Junio C Hamano |
Junio C Hamano | 5fec3ef | 2005-06-25 02:22:05 -0700 | [diff] [blame] | 5 | |
Steven Grimm | d1cc130 | 2007-07-22 21:17:42 -0700 | [diff] [blame] | 6 | USAGE='[-a | --interactive] [-s] [-v] [--no-verify] [-m <message> | -F <logfile> | (-C|-c) <commit> | --amend] [-u] [-e] [--author <author>] [--template <file>] [[-i | -o] <path>...]' |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 7 | SUBDIRECTORY_OK=Yes |
Junio C Hamano | 8f321a3 | 2007-11-06 01:50:02 -0800 | [diff] [blame] | 8 | OPTIONS_SPEC= |
Junio C Hamano | ae2b0f1 | 2005-11-24 00:12:11 -0800 | [diff] [blame] | 9 | . git-sh-setup |
Shawn O. Pearce | 7eff28a | 2006-12-30 23:32:38 -0500 | [diff] [blame] | 10 | require_work_tree |
Linus Torvalds | b33e966 | 2005-07-08 10:57:21 -0700 | [diff] [blame] | 11 | |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 12 | git rev-parse --verify HEAD >/dev/null 2>&1 || initial_commit=t |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 13 | |
| 14 | case "$0" in |
| 15 | *status) |
| 16 | status_only=t |
Junio C Hamano | 2b5f9a8 | 2007-02-22 00:28:49 -0800 | [diff] [blame] | 17 | ;; |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 18 | *commit) |
| 19 | status_only= |
Junio C Hamano | 2b5f9a8 | 2007-02-22 00:28:49 -0800 | [diff] [blame] | 20 | ;; |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 21 | esac |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 22 | |
| 23 | refuse_partial () { |
| 24 | echo >&2 "$1" |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 25 | echo >&2 "You might have meant to say 'git commit -i paths...', perhaps?" |
| 26 | exit 1 |
| 27 | } |
| 28 | |
Junio C Hamano | c8f2032 | 2007-10-02 11:47:58 -0700 | [diff] [blame] | 29 | TMP_INDEX= |
Rémi Vanicat | 859a4db | 2007-11-11 13:28:08 +0100 | [diff] [blame] | 30 | THIS_INDEX="${GIT_INDEX_FILE:-$GIT_DIR/index}" |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 31 | NEXT_INDEX="$GIT_DIR/next-index$$" |
| 32 | rm -f "$NEXT_INDEX" |
Junio C Hamano | 5a798fb | 2006-02-05 16:08:01 -0800 | [diff] [blame] | 33 | save_index () { |
Junio C Hamano | cc7d5bc | 2006-06-29 14:48:22 -0700 | [diff] [blame] | 34 | cp -p "$THIS_INDEX" "$NEXT_INDEX" |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 35 | } |
| 36 | |
Junio C Hamano | 5a798fb | 2006-02-05 16:08:01 -0800 | [diff] [blame] | 37 | run_status () { |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 38 | # If TMP_INDEX is defined, that means we are doing |
| 39 | # "--only" partial commit, and that index file is used |
| 40 | # to build the tree for the commit. Otherwise, if |
| 41 | # NEXT_INDEX exists, that is the index file used to |
| 42 | # make the commit. Otherwise we are using as-is commit |
| 43 | # so the regular index file is what we use to compare. |
| 44 | if test '' != "$TMP_INDEX" |
| 45 | then |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 46 | GIT_INDEX_FILE="$TMP_INDEX" |
| 47 | export GIT_INDEX_FILE |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 48 | elif test -f "$NEXT_INDEX" |
| 49 | then |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 50 | GIT_INDEX_FILE="$NEXT_INDEX" |
| 51 | export GIT_INDEX_FILE |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 52 | fi |
| 53 | |
Brian Hetro | 09b0d9d | 2007-08-26 14:35:26 -0400 | [diff] [blame] | 54 | if test "$status_only" = "t" -o "$use_status_color" = "t"; then |
| 55 | color= |
| 56 | else |
| 57 | color=--nocolor |
| 58 | fi |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 59 | git runstatus ${color} \ |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 60 | ${verbose:+--verbose} \ |
| 61 | ${amend:+--amend} \ |
Johannes Schindelin | 2074cb0 | 2006-09-12 22:45:12 +0200 | [diff] [blame] | 62 | ${untracked_files:+--untracked} |
Junio C Hamano | 5a798fb | 2006-02-05 16:08:01 -0800 | [diff] [blame] | 63 | } |
| 64 | |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 65 | trap ' |
| 66 | test -z "$TMP_INDEX" || { |
| 67 | test -f "$TMP_INDEX" && rm -f "$TMP_INDEX" |
| 68 | } |
| 69 | rm -f "$NEXT_INDEX" |
| 70 | ' 0 |
| 71 | |
| 72 | ################################################################ |
| 73 | # Command line argument parsing and sanity checking |
| 74 | |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 75 | all= |
| 76 | also= |
Junio C Hamano | 36863af | 2007-12-03 00:03:10 -0800 | [diff] [blame] | 77 | allow_empty=f |
Paolo Bonzini | 6cbf07e | 2007-03-05 08:57:53 +0100 | [diff] [blame] | 78 | interactive= |
Junio C Hamano | 5a798fb | 2006-02-05 16:08:01 -0800 | [diff] [blame] | 79 | only= |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 80 | logfile= |
| 81 | use_commit= |
Junio C Hamano | b4019f0 | 2006-03-02 21:04:05 -0800 | [diff] [blame] | 82 | amend= |
Jeff King | cda8ab5 | 2006-06-23 09:43:38 -0400 | [diff] [blame] | 83 | edit_flag= |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 84 | no_edit= |
| 85 | log_given= |
| 86 | log_message= |
| 87 | verify=t |
Nicolas Pitre | ebd124c | 2006-12-14 23:15:44 -0500 | [diff] [blame] | 88 | quiet= |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 89 | verbose= |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 90 | signoff= |
| 91 | force_author= |
Junio C Hamano | bba319b | 2006-02-14 12:40:20 -0800 | [diff] [blame] | 92 | only_include_assumed= |
Matthias Lederhofer | 443f833 | 2006-05-22 23:02:06 +0200 | [diff] [blame] | 93 | untracked_files= |
Steven Grimm | d1cc130 | 2007-07-22 21:17:42 -0700 | [diff] [blame] | 94 | templatefile="`git config commit.template`" |
David Kastrup | 822f7c7 | 2007-09-23 22:42:08 +0200 | [diff] [blame] | 95 | while test $# != 0 |
Junio C Hamano | 5fec3ef | 2005-06-25 02:22:05 -0700 | [diff] [blame] | 96 | do |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 97 | case "$1" in |
| 98 | -F|--F|-f|--f|--fi|--fil|--file) |
| 99 | case "$#" in 1) usage ;; esac |
| 100 | shift |
| 101 | no_edit=t |
| 102 | log_given=t$log_given |
| 103 | logfile="$1" |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 104 | ;; |
| 105 | -F*|-f*) |
| 106 | no_edit=t |
| 107 | log_given=t$log_given |
David Kastrup | d288404 | 2007-09-17 22:56:44 +0200 | [diff] [blame] | 108 | logfile="${1#-[Ff]}" |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 109 | ;; |
| 110 | --F=*|--f=*|--fi=*|--fil=*|--file=*) |
| 111 | no_edit=t |
| 112 | log_given=t$log_given |
David Kastrup | d288404 | 2007-09-17 22:56:44 +0200 | [diff] [blame] | 113 | logfile="${1#*=}" |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 114 | ;; |
| 115 | -a|--a|--al|--all) |
| 116 | all=t |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 117 | ;; |
Junio C Hamano | 36863af | 2007-12-03 00:03:10 -0800 | [diff] [blame] | 118 | --allo|--allow|--allow-|--allow-e|--allow-em|--allow-emp|\ |
| 119 | --allow-empt|--allow-empty) |
| 120 | allow_empty=t |
| 121 | ;; |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 122 | --au=*|--aut=*|--auth=*|--autho=*|--author=*) |
David Kastrup | d288404 | 2007-09-17 22:56:44 +0200 | [diff] [blame] | 123 | force_author="${1#*=}" |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 124 | ;; |
| 125 | --au|--aut|--auth|--autho|--author) |
| 126 | case "$#" in 1) usage ;; esac |
| 127 | shift |
| 128 | force_author="$1" |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 129 | ;; |
| 130 | -e|--e|--ed|--edi|--edit) |
| 131 | edit_flag=t |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 132 | ;; |
| 133 | -i|--i|--in|--inc|--incl|--inclu|--includ|--include) |
| 134 | also=t |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 135 | ;; |
Paolo Bonzini | 6cbf07e | 2007-03-05 08:57:53 +0100 | [diff] [blame] | 136 | --int|--inte|--inter|--intera|--interac|--interact|--interacti|\ |
| 137 | --interactiv|--interactive) |
| 138 | interactive=t |
Paolo Bonzini | 6cbf07e | 2007-03-05 08:57:53 +0100 | [diff] [blame] | 139 | ;; |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 140 | -o|--o|--on|--onl|--only) |
| 141 | only=t |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 142 | ;; |
| 143 | -m|--m|--me|--mes|--mess|--messa|--messag|--message) |
| 144 | case "$#" in 1) usage ;; esac |
| 145 | shift |
| 146 | log_given=m$log_given |
David Kastrup | d288404 | 2007-09-17 22:56:44 +0200 | [diff] [blame] | 147 | log_message="${log_message:+${log_message} |
Shawn Pearce | 6891281 | 2006-05-29 04:45:49 -0400 | [diff] [blame] | 148 | |
David Kastrup | d288404 | 2007-09-17 22:56:44 +0200 | [diff] [blame] | 149 | }$1" |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 150 | no_edit=t |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 151 | ;; |
| 152 | -m*) |
| 153 | log_given=m$log_given |
David Kastrup | d288404 | 2007-09-17 22:56:44 +0200 | [diff] [blame] | 154 | log_message="${log_message:+${log_message} |
Shawn Pearce | 6891281 | 2006-05-29 04:45:49 -0400 | [diff] [blame] | 155 | |
David Kastrup | d288404 | 2007-09-17 22:56:44 +0200 | [diff] [blame] | 156 | }${1#-m}" |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 157 | no_edit=t |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 158 | ;; |
| 159 | --m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*) |
| 160 | log_given=m$log_given |
David Kastrup | d288404 | 2007-09-17 22:56:44 +0200 | [diff] [blame] | 161 | log_message="${log_message:+${log_message} |
Shawn Pearce | 6891281 | 2006-05-29 04:45:49 -0400 | [diff] [blame] | 162 | |
David Kastrup | d288404 | 2007-09-17 22:56:44 +0200 | [diff] [blame] | 163 | }${1#*=}" |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 164 | no_edit=t |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 165 | ;; |
| 166 | -n|--n|--no|--no-|--no-v|--no-ve|--no-ver|--no-veri|--no-verif|\ |
| 167 | --no-verify) |
| 168 | verify= |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 169 | ;; |
| 170 | --a|--am|--ame|--amen|--amend) |
| 171 | amend=t |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 172 | use_commit=HEAD |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 173 | ;; |
| 174 | -c) |
| 175 | case "$#" in 1) usage ;; esac |
| 176 | shift |
| 177 | log_given=t$log_given |
| 178 | use_commit="$1" |
| 179 | no_edit= |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 180 | ;; |
| 181 | --ree=*|--reed=*|--reedi=*|--reedit=*|--reedit-=*|--reedit-m=*|\ |
| 182 | --reedit-me=*|--reedit-mes=*|--reedit-mess=*|--reedit-messa=*|\ |
| 183 | --reedit-messag=*|--reedit-message=*) |
| 184 | log_given=t$log_given |
David Kastrup | d288404 | 2007-09-17 22:56:44 +0200 | [diff] [blame] | 185 | use_commit="${1#*=}" |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 186 | no_edit= |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 187 | ;; |
| 188 | --ree|--reed|--reedi|--reedit|--reedit-|--reedit-m|--reedit-me|\ |
| 189 | --reedit-mes|--reedit-mess|--reedit-messa|--reedit-messag|\ |
| 190 | --reedit-message) |
| 191 | case "$#" in 1) usage ;; esac |
| 192 | shift |
| 193 | log_given=t$log_given |
| 194 | use_commit="$1" |
| 195 | no_edit= |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 196 | ;; |
| 197 | -C) |
| 198 | case "$#" in 1) usage ;; esac |
| 199 | shift |
| 200 | log_given=t$log_given |
| 201 | use_commit="$1" |
| 202 | no_edit=t |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 203 | ;; |
| 204 | --reu=*|--reus=*|--reuse=*|--reuse-=*|--reuse-m=*|--reuse-me=*|\ |
| 205 | --reuse-mes=*|--reuse-mess=*|--reuse-messa=*|--reuse-messag=*|\ |
| 206 | --reuse-message=*) |
| 207 | log_given=t$log_given |
David Kastrup | d288404 | 2007-09-17 22:56:44 +0200 | [diff] [blame] | 208 | use_commit="${1#*=}" |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 209 | no_edit=t |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 210 | ;; |
| 211 | --reu|--reus|--reuse|--reuse-|--reuse-m|--reuse-me|--reuse-mes|\ |
| 212 | --reuse-mess|--reuse-messa|--reuse-messag|--reuse-message) |
| 213 | case "$#" in 1) usage ;; esac |
| 214 | shift |
| 215 | log_given=t$log_given |
| 216 | use_commit="$1" |
| 217 | no_edit=t |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 218 | ;; |
| 219 | -s|--s|--si|--sig|--sign|--signo|--signof|--signoff) |
| 220 | signoff=t |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 221 | ;; |
Steven Grimm | d1cc130 | 2007-07-22 21:17:42 -0700 | [diff] [blame] | 222 | -t|--t|--te|--tem|--temp|--templ|--templa|--templat|--template) |
| 223 | case "$#" in 1) usage ;; esac |
| 224 | shift |
| 225 | templatefile="$1" |
| 226 | no_edit= |
Steven Grimm | d1cc130 | 2007-07-22 21:17:42 -0700 | [diff] [blame] | 227 | ;; |
Nicolas Pitre | ebd124c | 2006-12-14 23:15:44 -0500 | [diff] [blame] | 228 | -q|--q|--qu|--qui|--quie|--quiet) |
| 229 | quiet=t |
Nicolas Pitre | ebd124c | 2006-12-14 23:15:44 -0500 | [diff] [blame] | 230 | ;; |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 231 | -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose) |
| 232 | verbose=t |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 233 | ;; |
| 234 | -u|--u|--un|--unt|--untr|--untra|--untrac|--untrack|--untracke|\ |
| 235 | --untracked|--untracked-|--untracked-f|--untracked-fi|--untracked-fil|\ |
| 236 | --untracked-file|--untracked-files) |
| 237 | untracked_files=t |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 238 | ;; |
| 239 | --) |
| 240 | shift |
| 241 | break |
| 242 | ;; |
| 243 | -*) |
| 244 | usage |
| 245 | ;; |
| 246 | *) |
| 247 | break |
| 248 | ;; |
| 249 | esac |
David Kastrup | d288404 | 2007-09-17 22:56:44 +0200 | [diff] [blame] | 250 | shift |
Junio C Hamano | 5fec3ef | 2005-06-25 02:22:05 -0700 | [diff] [blame] | 251 | done |
Jeff King | cda8ab5 | 2006-06-23 09:43:38 -0400 | [diff] [blame] | 252 | case "$edit_flag" in t) no_edit= ;; esac |
Junio C Hamano | 5fec3ef | 2005-06-25 02:22:05 -0700 | [diff] [blame] | 253 | |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 254 | ################################################################ |
| 255 | # Sanity check options |
| 256 | |
Junio C Hamano | b4019f0 | 2006-03-02 21:04:05 -0800 | [diff] [blame] | 257 | case "$amend,$initial_commit" in |
| 258 | t,t) |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 259 | die "You do not have anything to amend." ;; |
Junio C Hamano | b4019f0 | 2006-03-02 21:04:05 -0800 | [diff] [blame] | 260 | t,) |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 261 | if [ -f "$GIT_DIR/MERGE_HEAD" ]; then |
| 262 | die "You are in the middle of a merge -- cannot amend." |
| 263 | fi ;; |
Junio C Hamano | b4019f0 | 2006-03-02 21:04:05 -0800 | [diff] [blame] | 264 | esac |
| 265 | |
Junio C Hamano | 0c09129 | 2005-08-08 17:03:14 -0700 | [diff] [blame] | 266 | case "$log_given" in |
| 267 | tt*) |
Junio C Hamano | 6d4bbeb | 2007-08-01 18:14:41 -0700 | [diff] [blame] | 268 | die "Only one of -c/-C/-F can be used." ;; |
Shawn Pearce | 6891281 | 2006-05-29 04:45:49 -0400 | [diff] [blame] | 269 | *tm*|*mt*) |
Junio C Hamano | 6d4bbeb | 2007-08-01 18:14:41 -0700 | [diff] [blame] | 270 | die "Option -m cannot be combined with -c/-C/-F." ;; |
Junio C Hamano | 0c09129 | 2005-08-08 17:03:14 -0700 | [diff] [blame] | 271 | esac |
| 272 | |
Junio C Hamano | 6a74642 | 2006-04-20 01:20:56 -0700 | [diff] [blame] | 273 | case "$#,$also,$only,$amend" in |
| 274 | *,t,t,*) |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 275 | die "Only one of --include/--only can be used." ;; |
Junio C Hamano | 6a74642 | 2006-04-20 01:20:56 -0700 | [diff] [blame] | 276 | 0,t,,* | 0,,t,) |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 277 | die "No paths with --include/--only does not make sense." ;; |
Junio C Hamano | 6a74642 | 2006-04-20 01:20:56 -0700 | [diff] [blame] | 278 | 0,,t,t) |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 279 | only_include_assumed="# Clever... amending the last one with dirty index." ;; |
Junio C Hamano | 6a74642 | 2006-04-20 01:20:56 -0700 | [diff] [blame] | 280 | 0,,,*) |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 281 | ;; |
Junio C Hamano | 6a74642 | 2006-04-20 01:20:56 -0700 | [diff] [blame] | 282 | *,,,*) |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 283 | only_include_assumed="# Explicit paths specified without -i nor -o; assuming --only paths..." |
| 284 | also= |
| 285 | ;; |
Junio C Hamano | 5a798fb | 2006-02-05 16:08:01 -0800 | [diff] [blame] | 286 | esac |
| 287 | unset only |
Paolo Bonzini | 6cbf07e | 2007-03-05 08:57:53 +0100 | [diff] [blame] | 288 | case "$all,$interactive,$also,$#" in |
| 289 | *t,*t,*) |
| 290 | die "Cannot use -a, --interactive or -i at the same time." ;; |
Björn Steinbrink | 34cb704 | 2007-11-05 20:36:33 +0100 | [diff] [blame] | 291 | t,,,[1-9]*) |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 292 | die "Paths with -a does not make sense." ;; |
Björn Steinbrink | 34cb704 | 2007-11-05 20:36:33 +0100 | [diff] [blame] | 293 | ,t,,[1-9]*) |
Paolo Bonzini | 6cbf07e | 2007-03-05 08:57:53 +0100 | [diff] [blame] | 294 | die "Paths with --interactive does not make sense." ;; |
| 295 | ,,t,0) |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 296 | die "No paths with -i does not make sense." ;; |
| 297 | esac |
| 298 | |
Steven Grimm | d1cc130 | 2007-07-22 21:17:42 -0700 | [diff] [blame] | 299 | if test ! -z "$templatefile" -a -z "$log_given" |
| 300 | then |
| 301 | if test ! -f "$templatefile" |
| 302 | then |
| 303 | die "Commit template file does not exist." |
| 304 | fi |
| 305 | fi |
| 306 | |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 307 | ################################################################ |
| 308 | # Prepare index to have a tree to be committed |
Junio C Hamano | 5a798fb | 2006-02-05 16:08:01 -0800 | [diff] [blame] | 309 | |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 310 | case "$all,$also" in |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 311 | t,) |
Fredrik Kuivinen | 755b99d | 2007-02-22 21:28:12 +0100 | [diff] [blame] | 312 | if test ! -f "$THIS_INDEX" |
| 313 | then |
| 314 | die 'nothing to commit (use "git add file1 file2" to include for commit)' |
| 315 | fi |
Junio C Hamano | 5a798fb | 2006-02-05 16:08:01 -0800 | [diff] [blame] | 316 | save_index && |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 317 | ( |
Junio C Hamano | 514c09f | 2007-01-12 12:49:05 -0800 | [diff] [blame] | 318 | cd_to_toplevel && |
| 319 | GIT_INDEX_FILE="$NEXT_INDEX" && |
| 320 | export GIT_INDEX_FILE && |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 321 | git diff-files --name-only -z | |
| 322 | git update-index --remove -z --stdin |
Junio C Hamano | 514c09f | 2007-01-12 12:49:05 -0800 | [diff] [blame] | 323 | ) || exit |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 324 | ;; |
| 325 | ,t) |
Junio C Hamano | 5a798fb | 2006-02-05 16:08:01 -0800 | [diff] [blame] | 326 | save_index && |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 327 | git ls-files --error-unmatch -- "$@" >/dev/null || exit |
Junio C Hamano | bba319b | 2006-02-14 12:40:20 -0800 | [diff] [blame] | 328 | |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 329 | git diff-files --name-only -z -- "$@" | |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 330 | ( |
Junio C Hamano | 514c09f | 2007-01-12 12:49:05 -0800 | [diff] [blame] | 331 | cd_to_toplevel && |
| 332 | GIT_INDEX_FILE="$NEXT_INDEX" && |
| 333 | export GIT_INDEX_FILE && |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 334 | git update-index --remove -z --stdin |
Junio C Hamano | 514c09f | 2007-01-12 12:49:05 -0800 | [diff] [blame] | 335 | ) || exit |
Junio C Hamano | 22cff6a | 2005-08-16 18:08:19 -0700 | [diff] [blame] | 336 | ;; |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 337 | ,) |
Paolo Bonzini | 6cbf07e | 2007-03-05 08:57:53 +0100 | [diff] [blame] | 338 | if test "$interactive" = t; then |
| 339 | git add --interactive || exit |
| 340 | fi |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 341 | case "$#" in |
| 342 | 0) |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 343 | ;; # commit as-is |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 344 | *) |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 345 | if test -f "$GIT_DIR/MERGE_HEAD" |
| 346 | then |
| 347 | refuse_partial "Cannot do a partial commit during a merge." |
| 348 | fi |
Junio C Hamano | 80bffaf | 2007-09-12 16:04:22 -0700 | [diff] [blame] | 349 | |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 350 | TMP_INDEX="$GIT_DIR/tmp-index$$" |
Junio C Hamano | 80bffaf | 2007-09-12 16:04:22 -0700 | [diff] [blame] | 351 | W= |
| 352 | test -z "$initial_commit" && W=--with-tree=HEAD |
| 353 | commit_only=`git ls-files --error-unmatch $W -- "$@"` || exit |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 354 | |
Junio C Hamano | 158d057 | 2006-12-09 22:32:43 -0800 | [diff] [blame] | 355 | # Build a temporary index and update the real index |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 356 | # the same way. |
| 357 | if test -z "$initial_commit" |
| 358 | then |
Junio C Hamano | 5e7f56a | 2007-03-31 23:27:41 -0700 | [diff] [blame] | 359 | GIT_INDEX_FILE="$THIS_INDEX" \ |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 360 | git read-tree --index-output="$TMP_INDEX" -i -m HEAD |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 361 | else |
| 362 | rm -f "$TMP_INDEX" |
| 363 | fi || exit |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 364 | |
Junio C Hamano | 293623e | 2007-05-25 22:00:54 -0700 | [diff] [blame] | 365 | printf '%s\n' "$commit_only" | |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 366 | GIT_INDEX_FILE="$TMP_INDEX" \ |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 367 | git update-index --add --remove --stdin && |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 368 | |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 369 | save_index && |
Junio C Hamano | 293623e | 2007-05-25 22:00:54 -0700 | [diff] [blame] | 370 | printf '%s\n' "$commit_only" | |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 371 | ( |
| 372 | GIT_INDEX_FILE="$NEXT_INDEX" |
| 373 | export GIT_INDEX_FILE |
Junio C Hamano | db33af0 | 2007-09-14 16:53:58 -0700 | [diff] [blame] | 374 | git update-index --add --remove --stdin |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 375 | ) || exit |
| 376 | ;; |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 377 | esac |
Junio C Hamano | f678dd1 | 2005-11-25 13:33:14 -0800 | [diff] [blame] | 378 | ;; |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 379 | esac |
| 380 | |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 381 | ################################################################ |
| 382 | # If we do as-is commit, the index file will be THIS_INDEX, |
| 383 | # otherwise NEXT_INDEX after we make this commit. We leave |
| 384 | # the index as is if we abort. |
Junio C Hamano | 0c09129 | 2005-08-08 17:03:14 -0700 | [diff] [blame] | 385 | |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 386 | if test -f "$NEXT_INDEX" |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 387 | then |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 388 | USE_INDEX="$NEXT_INDEX" |
| 389 | else |
| 390 | USE_INDEX="$THIS_INDEX" |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 391 | fi |
| 392 | |
Junio C Hamano | 2b5f9a8 | 2007-02-22 00:28:49 -0800 | [diff] [blame] | 393 | case "$status_only" in |
| 394 | t) |
| 395 | # This will silently fail in a read-only repository, which is |
| 396 | # what we want. |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 397 | GIT_INDEX_FILE="$USE_INDEX" git update-index -q --unmerged --refresh |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 398 | run_status |
| 399 | exit $? |
Junio C Hamano | 2b5f9a8 | 2007-02-22 00:28:49 -0800 | [diff] [blame] | 400 | ;; |
| 401 | '') |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 402 | GIT_INDEX_FILE="$USE_INDEX" git update-index -q --refresh || exit |
Junio C Hamano | 2b5f9a8 | 2007-02-22 00:28:49 -0800 | [diff] [blame] | 403 | ;; |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 404 | esac |
| 405 | |
| 406 | ################################################################ |
| 407 | # Grab commit message, write out tree and make commit. |
| 408 | |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 409 | if test t = "$verify" && test -x "$GIT_DIR"/hooks/pre-commit |
| 410 | then |
David Kastrup | d288404 | 2007-09-17 22:56:44 +0200 | [diff] [blame] | 411 | GIT_INDEX_FILE="${TMP_INDEX:-${USE_INDEX}}" "$GIT_DIR"/hooks/pre-commit \ |
| 412 | || exit |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 413 | fi |
Junio C Hamano | 0cfe1d3 | 2005-08-12 23:39:15 -0700 | [diff] [blame] | 414 | |
Junio C Hamano | aba2da1 | 2005-08-25 18:57:35 -0700 | [diff] [blame] | 415 | if test "$log_message" != '' |
| 416 | then |
Junio C Hamano | 293623e | 2007-05-25 22:00:54 -0700 | [diff] [blame] | 417 | printf '%s\n' "$log_message" |
Junio C Hamano | aba2da1 | 2005-08-25 18:57:35 -0700 | [diff] [blame] | 418 | elif test "$logfile" != "" |
| 419 | then |
| 420 | if test "$logfile" = - |
| 421 | then |
| 422 | test -t 0 && |
| 423 | echo >&2 "(reading log message from standard input)" |
| 424 | cat |
| 425 | else |
| 426 | cat <"$logfile" |
| 427 | fi |
| 428 | elif test "$use_commit" != "" |
| 429 | then |
Tom Prince | e0d10e1 | 2007-01-28 16:16:53 -0800 | [diff] [blame] | 430 | encoding=$(git config i18n.commitencoding || echo UTF-8) |
Junio C Hamano | 5ac2715 | 2007-01-13 13:33:07 -0800 | [diff] [blame] | 431 | git show -s --pretty=raw --encoding="$encoding" "$use_commit" | |
| 432 | sed -e '1,/^$/d' -e 's/^ //' |
Luben Tuikov | a9cb3c6 | 2006-10-12 14:52:42 -0700 | [diff] [blame] | 433 | elif test -f "$GIT_DIR/MERGE_MSG" |
Junio C Hamano | e521580 | 2005-11-01 22:01:28 -0800 | [diff] [blame] | 434 | then |
| 435 | cat "$GIT_DIR/MERGE_MSG" |
Junio C Hamano | 7d0c688 | 2006-06-23 01:37:02 -0700 | [diff] [blame] | 436 | elif test -f "$GIT_DIR/SQUASH_MSG" |
| 437 | then |
| 438 | cat "$GIT_DIR/SQUASH_MSG" |
Steven Grimm | d1cc130 | 2007-07-22 21:17:42 -0700 | [diff] [blame] | 439 | elif test "$templatefile" != "" |
| 440 | then |
| 441 | cat "$templatefile" |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 442 | fi | git stripspace >"$GIT_DIR"/COMMIT_EDITMSG |
Junio C Hamano | 2d56993 | 2005-08-31 17:15:25 -0700 | [diff] [blame] | 443 | |
| 444 | case "$signoff" in |
| 445 | t) |
Todd Zullinger | 5354a56 | 2008-07-30 13:48:33 -0400 | [diff] [blame] | 446 | sign=$(git var GIT_COMMITTER_IDENT | sed -e ' |
Gerrit Pape | a734291 | 2007-07-06 14:42:27 +0000 | [diff] [blame] | 447 | s/>.*/>/ |
| 448 | s/^/Signed-off-by: / |
| 449 | ') |
| 450 | blank_before_signoff= |
Junio C Hamano | dbaa06a | 2007-01-29 01:06:27 -0800 | [diff] [blame] | 451 | tail -n 1 "$GIT_DIR"/COMMIT_EDITMSG | |
Gerrit Pape | a734291 | 2007-07-06 14:42:27 +0000 | [diff] [blame] | 452 | grep 'Signed-off-by:' >/dev/null || blank_before_signoff=' |
| 453 | ' |
| 454 | tail -n 1 "$GIT_DIR"/COMMIT_EDITMSG | |
| 455 | grep "$sign"$ >/dev/null || |
| 456 | printf '%s%s\n' "$blank_before_signoff" "$sign" \ |
| 457 | >>"$GIT_DIR"/COMMIT_EDITMSG |
Junio C Hamano | 2d56993 | 2005-08-31 17:15:25 -0700 | [diff] [blame] | 458 | ;; |
| 459 | esac |
| 460 | |
Junio C Hamano | 475443c | 2006-04-12 11:45:18 -0700 | [diff] [blame] | 461 | if test -f "$GIT_DIR/MERGE_HEAD" && test -z "$no_edit"; then |
Junio C Hamano | 2d56993 | 2005-08-31 17:15:25 -0700 | [diff] [blame] | 462 | echo "#" |
Alex Riesen | b6ae540 | 2006-01-05 12:44:59 +0100 | [diff] [blame] | 463 | echo "# It looks like you may be committing a MERGE." |
Junio C Hamano | 2d56993 | 2005-08-31 17:15:25 -0700 | [diff] [blame] | 464 | echo "# If this is not correct, please remove the file" |
Junio C Hamano | 293623e | 2007-05-25 22:00:54 -0700 | [diff] [blame] | 465 | printf '%s\n' "# $GIT_DIR/MERGE_HEAD" |
Junio C Hamano | 2d56993 | 2005-08-31 17:15:25 -0700 | [diff] [blame] | 466 | echo "# and try again" |
| 467 | echo "#" |
Santi_Béjar | f8e2c54 | 2005-10-09 17:30:19 -0700 | [diff] [blame] | 468 | fi >>"$GIT_DIR"/COMMIT_EDITMSG |
Junio C Hamano | aba2da1 | 2005-08-25 18:57:35 -0700 | [diff] [blame] | 469 | |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 470 | # Author |
Junio C Hamano | 83e24dc | 2007-01-22 13:03:31 -0800 | [diff] [blame] | 471 | if test '' != "$use_commit" |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 472 | then |
Johannes Schindelin | 0cae234 | 2007-06-25 01:04:11 +0100 | [diff] [blame] | 473 | eval "$(get_author_ident_from_commit "$use_commit")" |
| 474 | export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 475 | fi |
Junio C Hamano | 83e24dc | 2007-01-22 13:03:31 -0800 | [diff] [blame] | 476 | if test '' != "$force_author" |
| 477 | then |
| 478 | GIT_AUTHOR_NAME=`expr "z$force_author" : 'z\(.*[^ ]\) *<.*'` && |
| 479 | GIT_AUTHOR_EMAIL=`expr "z$force_author" : '.*\(<.*\)'` && |
| 480 | test '' != "$GIT_AUTHOR_NAME" && |
| 481 | test '' != "$GIT_AUTHOR_EMAIL" || |
| 482 | die "malformed --author parameter" |
| 483 | export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL |
| 484 | fi |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 485 | |
Linus Torvalds | 96069cf | 2005-06-14 10:20:14 -0700 | [diff] [blame] | 486 | PARENTS="-p HEAD" |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 487 | if test -z "$initial_commit" |
Junio C Hamano | 8098a17 | 2005-09-30 14:26:57 -0700 | [diff] [blame] | 488 | then |
Shawn Pearce | a3a733e | 2006-07-10 22:48:47 -0400 | [diff] [blame] | 489 | rloga='commit' |
Junio C Hamano | 5fec3ef | 2005-06-25 02:22:05 -0700 | [diff] [blame] | 490 | if [ -f "$GIT_DIR/MERGE_HEAD" ]; then |
Shawn Pearce | a3a733e | 2006-07-10 22:48:47 -0400 | [diff] [blame] | 491 | rloga='commit (merge)' |
Junio C Hamano | 91063bb | 2005-09-08 13:47:12 -0700 | [diff] [blame] | 492 | PARENTS="-p HEAD "`sed -e 's/^/-p /' "$GIT_DIR/MERGE_HEAD"` |
Junio C Hamano | b4019f0 | 2006-03-02 21:04:05 -0800 | [diff] [blame] | 493 | elif test -n "$amend"; then |
Shawn Pearce | a3a733e | 2006-07-10 22:48:47 -0400 | [diff] [blame] | 494 | rloga='commit (amend)' |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 495 | PARENTS=$(git cat-file commit HEAD | |
Junio C Hamano | b4019f0 | 2006-03-02 21:04:05 -0800 | [diff] [blame] | 496 | sed -n -e '/^$/q' -e 's/^parent /-p /p') |
Junio C Hamano | aba2da1 | 2005-08-25 18:57:35 -0700 | [diff] [blame] | 497 | fi |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 498 | current="$(git rev-parse --verify HEAD)" |
Junio C Hamano | 8098a17 | 2005-09-30 14:26:57 -0700 | [diff] [blame] | 499 | else |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 500 | if [ -z "$(git ls-files)" ]; then |
Shawn O. Pearce | aeb80c7 | 2006-12-15 21:53:09 -0500 | [diff] [blame] | 501 | echo >&2 'nothing to commit (use "git add file1 file2" to include for commit)' |
Junio C Hamano | 8098a17 | 2005-09-30 14:26:57 -0700 | [diff] [blame] | 502 | exit 1 |
| 503 | fi |
| 504 | PARENTS="" |
Shawn Pearce | a3a733e | 2006-07-10 22:48:47 -0400 | [diff] [blame] | 505 | rloga='commit (initial)' |
Junio C Hamano | cede752 | 2006-09-27 02:06:31 -0700 | [diff] [blame] | 506 | current='' |
Linus Torvalds | 96069cf | 2005-06-14 10:20:14 -0700 | [diff] [blame] | 507 | fi |
Junio C Hamano | 23913dc | 2007-01-19 17:12:11 -0800 | [diff] [blame] | 508 | set_reflog_action "$rloga" |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 509 | |
Junio C Hamano | 475443c | 2006-04-12 11:45:18 -0700 | [diff] [blame] | 510 | if test -z "$no_edit" |
| 511 | then |
| 512 | { |
Martin Waitz | 88a1531 | 2006-05-26 01:42:18 +0200 | [diff] [blame] | 513 | echo "" |
| 514 | echo "# Please enter the commit message for your changes." |
| 515 | echo "# (Comment lines starting with '#' will not be included)" |
Junio C Hamano | 475443c | 2006-04-12 11:45:18 -0700 | [diff] [blame] | 516 | test -z "$only_include_assumed" || echo "$only_include_assumed" |
| 517 | run_status |
| 518 | } >>"$GIT_DIR"/COMMIT_EDITMSG |
| 519 | else |
| 520 | # we need to check if there is anything to commit |
Junio C Hamano | a6080a0 | 2007-06-07 00:04:01 -0700 | [diff] [blame] | 521 | run_status >/dev/null |
Junio C Hamano | 475443c | 2006-04-12 11:45:18 -0700 | [diff] [blame] | 522 | fi |
Junio C Hamano | 36863af | 2007-12-03 00:03:10 -0800 | [diff] [blame] | 523 | case "$allow_empty,$?,$PARENTS" in |
| 524 | t,* | ?,0,* | ?,*,-p' '?*-p' '?*) |
| 525 | # an explicit --allow-empty, or a merge commit can record the |
| 526 | # same tree as its parent. Otherwise having commitable paths |
| 527 | # is required. |
Johannes Sixt | 13aba1e | 2007-12-03 08:24:50 +0100 | [diff] [blame] | 528 | ;; |
| 529 | *) |
Junio C Hamano | 7d0c688 | 2006-06-23 01:37:02 -0700 | [diff] [blame] | 530 | rm -f "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG" |
Brian Hetro | 09b0d9d | 2007-08-26 14:35:26 -0400 | [diff] [blame] | 531 | use_status_color=t |
Junio C Hamano | 5a798fb | 2006-02-05 16:08:01 -0800 | [diff] [blame] | 532 | run_status |
Linus Torvalds | a3e870f | 2005-05-30 12:51:00 -0700 | [diff] [blame] | 533 | exit 1 |
Johannes Sixt | 13aba1e | 2007-12-03 08:24:50 +0100 | [diff] [blame] | 534 | esac |
Junio C Hamano | 475443c | 2006-04-12 11:45:18 -0700 | [diff] [blame] | 535 | |
Junio C Hamano | 0c09129 | 2005-08-08 17:03:14 -0700 | [diff] [blame] | 536 | case "$no_edit" in |
Junio C Hamano | 5fec3ef | 2005-06-25 02:22:05 -0700 | [diff] [blame] | 537 | '') |
Todd Zullinger | 5354a56 | 2008-07-30 13:48:33 -0400 | [diff] [blame] | 538 | git var GIT_AUTHOR_IDENT > /dev/null || die |
| 539 | git var GIT_COMMITTER_IDENT > /dev/null || die |
Adam Roben | ef0c2ab | 2007-07-19 22:09:35 -0700 | [diff] [blame] | 540 | git_editor "$GIT_DIR/COMMIT_EDITMSG" |
Junio C Hamano | 5fec3ef | 2005-06-25 02:22:05 -0700 | [diff] [blame] | 541 | ;; |
| 542 | esac |
Junio C Hamano | 89e2c5f | 2005-08-18 17:20:08 -0700 | [diff] [blame] | 543 | |
| 544 | case "$verify" in |
| 545 | t) |
| 546 | if test -x "$GIT_DIR"/hooks/commit-msg |
| 547 | then |
Santi_Béjar | f8e2c54 | 2005-10-09 17:30:19 -0700 | [diff] [blame] | 548 | "$GIT_DIR"/hooks/commit-msg "$GIT_DIR"/COMMIT_EDITMSG || exit |
Junio C Hamano | 89e2c5f | 2005-08-18 17:20:08 -0700 | [diff] [blame] | 549 | fi |
| 550 | esac |
| 551 | |
Yann Dirson | 29f4ad8 | 2006-06-24 00:04:05 +0200 | [diff] [blame] | 552 | if test -z "$no_edit" |
| 553 | then |
| 554 | sed -e ' |
| 555 | /^diff --git a\/.*/{ |
| 556 | s/// |
| 557 | q |
| 558 | } |
| 559 | /^#/d |
| 560 | ' "$GIT_DIR"/COMMIT_EDITMSG |
| 561 | else |
| 562 | cat "$GIT_DIR"/COMMIT_EDITMSG |
| 563 | fi | |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 564 | git stripspace >"$GIT_DIR"/COMMIT_MSG |
Santi_Béjar | f8e2c54 | 2005-10-09 17:30:19 -0700 | [diff] [blame] | 565 | |
Steven Grimm | d1cc130 | 2007-07-22 21:17:42 -0700 | [diff] [blame] | 566 | # Test whether the commit message has any content we didn't supply. |
| 567 | have_commitmsg= |
| 568 | grep -v -i '^Signed-off-by' "$GIT_DIR"/COMMIT_MSG | |
| 569 | git stripspace > "$GIT_DIR"/COMMIT_BAREMSG |
| 570 | |
| 571 | # Is the commit message totally empty? |
| 572 | if test -s "$GIT_DIR"/COMMIT_BAREMSG |
| 573 | then |
| 574 | if test "$templatefile" != "" |
| 575 | then |
| 576 | # Test whether this is just the unaltered template. |
| 577 | if cnt=`sed -e '/^#/d' < "$templatefile" | |
| 578 | git stripspace | |
| 579 | diff "$GIT_DIR"/COMMIT_BAREMSG - | |
| 580 | wc -l` && |
| 581 | test 0 -lt $cnt |
| 582 | then |
| 583 | have_commitmsg=t |
| 584 | fi |
| 585 | else |
| 586 | # No template, so the content in the commit message must |
| 587 | # have come from the user. |
| 588 | have_commitmsg=t |
| 589 | fi |
| 590 | fi |
| 591 | |
| 592 | rm -f "$GIT_DIR"/COMMIT_BAREMSG |
| 593 | |
| 594 | if test "$have_commitmsg" = "t" |
Junio C Hamano | 0c09129 | 2005-08-08 17:03:14 -0700 | [diff] [blame] | 595 | then |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 596 | if test -z "$TMP_INDEX" |
| 597 | then |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 598 | tree=$(GIT_INDEX_FILE="$USE_INDEX" git write-tree) |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 599 | else |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 600 | tree=$(GIT_INDEX_FILE="$TMP_INDEX" git write-tree) && |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 601 | rm -f "$TMP_INDEX" |
| 602 | fi && |
Josh Triplett | 9d6f220 | 2007-07-14 01:05:43 -0700 | [diff] [blame] | 603 | commit=$(git commit-tree $tree $PARENTS <"$GIT_DIR/COMMIT_MSG") && |
Shawn Pearce | 67644a4 | 2006-05-19 05:16:18 -0400 | [diff] [blame] | 604 | rlogm=$(sed -e 1q "$GIT_DIR"/COMMIT_MSG) && |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 605 | git update-ref -m "$GIT_REFLOG_ACTION: $rlogm" HEAD $commit "$current" && |
Luben Tuikov | a9cb3c6 | 2006-10-12 14:52:42 -0700 | [diff] [blame] | 606 | rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" && |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 607 | if test -f "$NEXT_INDEX" |
| 608 | then |
| 609 | mv "$NEXT_INDEX" "$THIS_INDEX" |
| 610 | else |
| 611 | : ;# happy |
| 612 | fi |
Junio C Hamano | 0c09129 | 2005-08-08 17:03:14 -0700 | [diff] [blame] | 613 | else |
| 614 | echo >&2 "* no commit message? aborting commit." |
| 615 | false |
| 616 | fi |
Linus Torvalds | 170241b | 2005-06-19 19:57:01 -0700 | [diff] [blame] | 617 | ret="$?" |
Junio C Hamano | 7d0c688 | 2006-06-23 01:37:02 -0700 | [diff] [blame] | 618 | rm -f "$GIT_DIR/COMMIT_MSG" "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG" |
Junio C Hamano | c93d88a | 2007-03-05 12:35:41 -0800 | [diff] [blame] | 619 | |
| 620 | cd_to_toplevel |
| 621 | |
Johannes Schindelin | b4372ef | 2007-07-06 13:05:59 +0100 | [diff] [blame] | 622 | git rerere |
Junio C Hamano | 89e2c5f | 2005-08-18 17:20:08 -0700 | [diff] [blame] | 623 | |
Nicolas Pitre | ebd124c | 2006-12-14 23:15:44 -0500 | [diff] [blame] | 624 | if test "$ret" = 0 |
Junio C Hamano | 89e2c5f | 2005-08-18 17:20:08 -0700 | [diff] [blame] | 625 | then |
Junio C Hamano | d4bb43e | 2007-09-05 14:59:59 -0700 | [diff] [blame] | 626 | git gc --auto |
Nicolas Pitre | ebd124c | 2006-12-14 23:15:44 -0500 | [diff] [blame] | 627 | if test -x "$GIT_DIR"/hooks/post-commit |
| 628 | then |
| 629 | "$GIT_DIR"/hooks/post-commit |
| 630 | fi |
| 631 | if test -z "$quiet" |
| 632 | then |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 633 | commit=`git diff-tree --always --shortstat --pretty="format:%h: %s"\ |
Jonathan Nieder | 7f1592d | 2010-07-27 13:44:51 -0500 | [diff] [blame] | 634 | --abbrev --summary --root HEAD --` |
Nicolas Pitre | ebd124c | 2006-12-14 23:15:44 -0500 | [diff] [blame] | 635 | echo "Created${initial_commit:+ initial} commit $commit" |
Nicolas Pitre | ebd124c | 2006-12-14 23:15:44 -0500 | [diff] [blame] | 636 | fi |
Junio C Hamano | 89e2c5f | 2005-08-18 17:20:08 -0700 | [diff] [blame] | 637 | fi |
Junio C Hamano | 61f5cb7 | 2006-10-24 21:48:55 -0700 | [diff] [blame] | 638 | |
Linus Torvalds | 170241b | 2005-06-19 19:57:01 -0700 | [diff] [blame] | 639 | exit "$ret" |